/*
 * Ahriboy...Hummmm....so gooood!
 * A Plan Adr = c000
 * window adr = b000
 * B Plan adr = e000
 * sprite adr = be00
 * HScrol adr = b800
 */

#include "genesis.h"
#include "conio.h"
#include "ctype.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"


#include "pal_ico.h"
#include "fille1.h"
#include "title.h"
#include "splash.h"

#define ADR_TALK        ( 32 * 96 )
#define ADR_SEE         ( ADR_TALK  + 32 * 2 * 3 )
#define ADR_TOUCH       ( ADR_SEE   + 32 * 2 * 3 )
#define ADR_SEX         ( ADR_TOUCH + 32 * 2 * 3 )
#define ADR_CUR		( ADR_SEX   + 32 * 2 * 3 )
#define ADR_IMG		( ADR_CUR   + 32 * 2 * 2 )
#define ADR_TITLE1      ADR_TALK
#define ADR_TITLE2      ( ADR_TITLE1+ 32 * 23 * 7 )
#define ADR_SPLASH      ADR_TALK

#define ON_TALK		0
#define ON_SEE		1
#define ON_TOUCH	2
#define ON_SEX		3

/************** Function prototypes *************/
void init_gfx();

void test_girl(action);
void Kumiko(action);
void wait_press();
void wait_sec(nb_sec);
void erase_text();
void GameOver();
void End();

void onVBL();
/*************  External Vars *************/

/* in CHARSET.S */
extern ulong tiledata[];

/* in ICONES.S */
extern ulong ico_talk[];
extern ulong ico_see[];
extern ulong ico_touch[];
extern ulong ico_sex[];
extern ulong cursor[];


/* in TITLEx.S */
extern ulong title1[];
extern ulong title2[];

/* in SPLASH.S */
extern ulong splash[];


/* in FILLEx.S */
extern ulong fille1_a[];
extern ulong fille1_b[];
extern ulong fille1_c[];
extern ulong fille1_d[];
extern ulong fille1_e[];
extern ulong fille1_f[];

/* in HUMMM.S */
extern uchar HUMMM[];
extern uchar HUMMM_END[];

/* in JOUI.S */
extern uchar JOUI[];
extern uchar JOUI_END[];

/*  in LOGO.C  */
extern Logo();


extern reboot();

/*************    Variables  *************/
/* state = (nb_grl)*100 +  (nb_image)*10 + (nb_substate) */
uint State;


/*************  Main program  ***********/
void main()
{
    uint i;
    uint CurPos;
    uint tag;
    char buff[40];

    /* Initialize Genesis GFX registers */
    init_gfx();

    wait_sync();
    
    Logo();

    for (i=0; i<20; i++)
        wait_sync();


    /* Load the charset*/
    dma_vram_copy(tiledata  , 0         , 32 * 96 );

    /* def palette for icone&curs */
    set_colors(0,pal_ico);     


    /* Load title */
    dma_vram_copy(title1  , ADR_TITLE1 , 32 * 23 * 7 );
    dma_vram_copy(title2  , ADR_TITLE2 , 32 * 24 * 13);

    for (i=0; i<7; i++)
        show_tiles((i*23)+ADR_TITLE1/32 , (i*23) + 22 + ADR_TITLE1/32 , 2, 5, 2+i, APLAN, 0);

    for (i=0; i<13; i++)
        show_tiles((i*24)+ADR_TITLE2/32 , (i*24) + 23 + ADR_TITLE2/32 , 2, 5, 12+i, APLAN, 0);

    set_colors(2, pal_title);

    gotoxy(8,27);
    outtext_xy("(c)1999 DevBros",0, APLAN);

    wait_press();

    clrscr();

    gotoxy(1,2);
    outtext_xy("Ahriboy, notre heros national.",0, APLAN);

    gotoxy(1,4);
    outtext_xy("Meme Superman a besoin de lui.",0, APLAN);

    gotoxy(1,6);
    outtext_xy("Apres avoir sauve le Pape.",0, APLAN);

    gotoxy(1,8);
    outtext_xy("Apres avoir sauve, au peril de", 0, APLAN);
    gotoxy(1,9);
    outtext_xy("sa vie, un couple de ragondins.",0, APLAN);

    gotoxy(1,11);
    outtext_xy("Notre heros prend donc quelques",0, APLAN);
    gotoxy(1,12);
    outtext_xy("jours de repos bien merites et",0, APLAN);
    gotoxy(1,13);
    outtext_xy("en profite pour rendre visite",0, APLAN);
    gotoxy(1,14);
    outtext_xy("a son ami le roi de Viagraland.",0, APLAN);

    gotoxy(1,16);
    outtext_xy("Sur les lieux, il remarque la",0, APLAN);
    gotoxy(1,17);
    outtext_xy("jeune fille du roi.",0, APLAN);

    gotoxy(1,19);
    outtext_xy("Mais.....",0, APLAN);


    wait_sync();

 
    wait_press();


    clrscr();


    gotoxy(1,3);
    outtext_xy("Kumiko  Sniffff....",0, APLAN);

    wait_sec(60);

    gotoxy(1,6);
    outtext_xy("Ahriboy ??????",0, APLAN);


    wait_sec(60);

    gotoxy(1,9);
    outtext_xy("Kumiko  OUINNNNNN!!!",0, APLAN);


    wait_sec(60);

    gotoxy(1,12);
    outtext_xy("Ahriboy Et bien Kumiko?",0, APLAN);
    gotoxy(1,13);
    outtext_xy("        Que t'arrive-t-il?",0, APLAN);


    wait_press();


    clrscr();


    /* Load the first Girl : Kumiko */
    dma_vram_copy(fille1_a  , ADR_IMG , 32 * 32 * 19);


    /* Put it to the screen */
    show_tiles(ADR_IMG/32 , 32*19 + ADR_IMG/32 , 1, 0, 3, APLAN, 0);

    fade_in(pal_fille1, 1);


    /*load icons*/
    dma_vram_copy(ico_talk  , ADR_TALK  , 32 * 2 * 3);
    dma_vram_copy(ico_see   , ADR_SEE   , 32 * 2 * 3);
    dma_vram_copy(ico_touch , ADR_TOUCH , 32 * 2 * 3);
    dma_vram_copy(ico_sex   , ADR_SEX   , 32 * 2 * 3);
    dma_vram_copy(cursor    , ADR_CUR   , 32 * 2 * 2);

    /* put icones to screen */
    show_tiles(ADR_TALK/32   , 2 + ADR_TALK/32  , 0, 4 , 1, APLAN, 0);    
    show_tiles(3+ADR_TALK/32 , 5 + ADR_TALK/32  , 0, 4 , 2, APLAN, 0);    
    show_tiles(ADR_SEE/32    , 2 + ADR_SEE/32   , 0, 11, 1, APLAN, 0);
    show_tiles(3+ADR_SEE/32  , 5 + ADR_SEE/32   , 0, 11, 2, APLAN, 0);
    show_tiles(ADR_TOUCH/32  , 2 + ADR_TOUCH/32 , 0, 18, 1, APLAN, 0);    
    show_tiles(3+ADR_TOUCH/32, 5 + ADR_TOUCH/32 , 0, 18, 2, APLAN, 0);    
    show_tiles(ADR_SEX/32    , 2 + ADR_SEX/32   , 0, 25, 1, APLAN, 0);    
    show_tiles(3+ADR_SEX/32  , 5 + ADR_SEX/32   , 0, 25, 2, APLAN, 0);    
    

    /* create cursor */
    def_sprite(1, 8*6, 8, 0x500, 0x2000 + ADR_CUR/32);
    show_sprite(1, 1);
    CurPos = ON_TALK;

/*  State=110; */

    gotoxy(1, 22);
    outtext_xy("Kumiko", 0, APLAN);
    gotoxy(9, 22);
    outtext_xy("Personne ne m'aime!!", 0, APLAN);
    gotoxy(9, 23);
    outtext_xy("C'est parce que je suis", 0, APLAN);
    gotoxy(9, 24);
    outtext_xy("grosse et laide.       ", 0, APLAN);
    

    State=111;
    
    
    init_joypad();
    
    while(1)
    {
  		i=read_joypad1();

                if (i)
                {
                        switch(i&0xff)
                        {
                                case JOY_LEFT:
                                	if (CurPos == ON_TALK)
                                		CurPos = ON_SEX;
                                	else
                                		CurPos--;
                                        def_sprite(1, 8* (6 + (7*CurPos)), 8, 0x500, 0x2000 + ADR_CUR/32);
				        show_sprite(1, 1);
				        break;
                                case JOY_RIGHT:
                                	if (CurPos == ON_SEX)
                                		CurPos = ON_TALK;
                                	else
                                		CurPos++;
                                        def_sprite(1, 8* (6 + (7*CurPos)), 8, 0x500, 0x2000 + ADR_CUR/32);
				        show_sprite(1, 1);
				        break;
				case BUTTON_A:
                                        test_girl(CurPos);
                                        break;
                         }
                         wait_sec(5);

                  }					                               	
    }
}

/*
 * Initilize the GFX.
 */
void init_gfx()
{
    register uint *pw;

    pw = (uint *) GFXCNTL;

    *pw = 0x8016;   /* reg. 0 - Enable HBL */
    *pw = 0x8174;   /* reg. 1 - Enable display, VBL, DMA + VCell size */
    *pw = 0x8230;   /* reg. 2 - Plane A =$30*$400=$C000 */
    *pw = 0x832C;   /* reg. 3 - Window  =$38*$400=$D000 */
    *pw = 0x8407;   /* reg. 4 - Plane B =$7*$2000=$E000 */
    *pw = 0x855F;   /* reg. 5 - sprite table begins at $BE00=$5F*$200 */
    *pw = 0x8600;   /* reg. 6 - not used */
    *pw = 0x8700;   /* reg. 7 - Background Color number*/
    *pw = 0x8800;   /* reg. 8 - not used */
    *pw = 0x8900;   /* reg. 9 - not used */
    *pw = 0x8a01;   /* reg 10 - HInterrupt timing */
    *pw = 0x8b00;   /* reg 11 - $0000abcd a=extr.int b=vscr cd=hscr */
    *pw = 0x8c08;   /* reg 12 - hcell mode + shadow/highight + interlaced mode */
    *pw = 0x8d2E;   /* reg 13 - HScoll Table = $B800 */
    *pw = 0x8e00;   /* reg 14 - not used */
    *pw = 0x8f02;   /* reg 15 - auto increment data */
    *pw = 0x9000;   /* reg 16 - scrl screen size */
    *pw = 0x9100;   /* reg 17 - window hpos */
    *pw = 0x92ff;   /* reg 18 - window vpos */
}


/* With who are you talking ? */
void test_girl(action)
uint action;
{
        switch(State/100)
	{
		case 1:
			Kumiko(action);
			break;
/*		case 2:
		case 3:
		case 4:*/
	}
}


void Kumiko(action)
uint action;
{

        uint i;

        erase_text();
        wait_sync();

        switch(State)
        {
                case 111:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Allons, allons...", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Que me dites-tu la?", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("La triste realite.", 0, APLAN);
                                        State=112;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Elle pleure la pauvre)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Ca va pas!)", 0, APLAN);
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous vouliez juste", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("mon corps!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;


                case 112:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mais c'est faux!!", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Je suis moche, vous", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("n'y pouvez rien.", 0, APLAN);
                                        State=113;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Mignonne la princesse)", 0, APLAN);                                        
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Ca va pas!)", 0, APLAN);
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous vouliez juste", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("me violez!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 113:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mais non...", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("SI! Je suis laide!", 0, APLAN);
                                        State=111;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ce que je vois est", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("tout sauf moche.", 0, APLAN);                                        
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Vous vous moquez...", 0, APLAN);
                                        State=114;
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(C'est pas l'envie", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("qui m'en manque...)", 0, APLAN);
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ces mensonges pour", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("du sexe!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 114:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Pas du tout!", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Je te trouve belle", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("et je le dis!", 0, APLAN);
                                        State=120;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_b  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Et ca, c'est joli?", 0, APLAN);
                                        State=121;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("MAIS?!!", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Vos yeux!!!!", 0, APLAN);                                        
                                        GameOver();
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Propriete du roi)", 0, APLAN);
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous vouliez juste", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("me violez!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 121:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Comment cela?", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Vous voyez...", 0, APLAN);
                                        State=110;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_a  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Personne ne m'aime!!", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("C'est parce que je suis", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("grosse et laide.", 0, APLAN);
                                        State=111;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mon dieu!!", 0, APLAN);                                        
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Je suis laide", 0, APLAN);                                        
                                        gotoxy(9, 24);
                                        outtext_xy("a ce point?", 0, APLAN);                                        
                                        State=122;
                                        break;
                                case ON_TOUCH:
                                        GameOver();
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ca vous exite?!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 122:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Bien au contraire!", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Mais vous avez vu", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("mes fesses?", 0, APLAN);
                                        State=123;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Hiiii!!!", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Que regardez-vous", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("avec ces yeux?!", 0, APLAN);                                        
                                        GameOver();
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(J'aimerais tant!)", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mes fesses vous", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("vous exitent?!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 123:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Et bien?", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Vous n'osez meme", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("pas les regarder!", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Oui...Elles sont", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("tres appetissantes!", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);                                        
                                        gotoxy(9, 24);
                                        outtext_xy("Elles sont dodues?!", 0, APLAN);                                        
                                        State=124;
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("N'en profitez pas!", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Une paire de", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("fesses et hop?!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 124:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mais non....", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Elles font envie...", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Vraiment?", 0, APLAN);
                                        State=130;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_c  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Meme ainsi, cela", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("vous fait envie?", 0, APLAN);
                                        State=131;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("ARRETEZ!", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Vous me faite peur!", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Je vais craquer!)", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ce n'est pas encore", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("l'heure de manger!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 131:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Voyons! Si ton pere", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("nous voyait!", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Repondez!", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Oui, je suis envieux", 0, APLAN);                                        
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Vraiment?", 0, APLAN);
                                        State=132;
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Je tremble trop)", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous revez!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 132:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Tu doutes de moi?", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Je ne sais pas...", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ta peau semble", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("tellement douce...", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Ce n'est qu'un mirage", 0, APLAN);
                                        State=133;
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Nooon!!!)", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("J'ai dit Touchez", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("pas Violez!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 133:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Pourquoi est-ce que", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("tu te hais tant?", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Je suis laide...", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Qu'elle est belle!)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Non!!", 0, APLAN);                                        
                                        gotoxy(9, 22);
                                        outtext_xy("Elle est bien douce", 0, APLAN);                                        
                                        State=140;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_d  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Partout, vous croyez?", 0, APLAN);
                                        State=141;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous vouliez juste", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("me violez!!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 141:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Kumiko...", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Oui?", 0, APLAN);
                                        State=142;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Douce et brillante", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("comme de la soie", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ta peau est douce", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("comme du velours", 0, APLAN);                                        
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);                                        
                                        gotoxy(9, 24);
                                        outtext_xy("Ah oui?", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mes seins ont de", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("l'effet sur vous?!", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 142:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mais ton pere...", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Au diable mon pere!", 0, APLAN);
                                        State=143;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Tes yeux....", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Ils sont si beaux!", 0, APLAN);
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("Laissez mes yeux...", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ta peau est douce", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("comme du velours", 0, APLAN);                                        
                                        gotoxy(1, 24);
                                        outtext_xy("Kumiko", 0, APLAN);                                        
                                        gotoxy(9, 22);
                                        outtext_xy("Ah oui?", 0, APLAN);                                        
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Non...", 0, APLAN);                                        
                                        break;
                        }
                        break;

                case 143:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Mais...", 0, APLAN);
                                        gotoxy(1, 23);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Chuuuut!", 0, APLAN);
                                        State=143;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(C'est trop...)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Hummmmm...", 0, APLAN);                                        
                                        State=150;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_e  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Monsieur Ahri!!", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Vous me rendez...", 0, APLAN);
                                        State=151;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Je...Non...", 0, APLAN);                                        
                                        break;
                        }
                        break;

                case 151:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Je me sens...", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Si bizarre...", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Son corps brille", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("sous la transpiration)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("OUIIIII!", 0, APLAN);                                        
                                        State=152;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Non...", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Caressez moi...", 0, APLAN);                                        
                                        State=152;
                                        break;
                        }
                        break;

                case 152:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ne parlez plus!", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("Agissez!", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Je suis dans", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("le brouillard)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Monsieur Ahri!!!!", 0, APLAN);                                        
                                        State=153;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Vous n'avez pas", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("explore tout", 0, APLAN);                                        
                                        gotoxy(9, 24);
                                        outtext_xy("mon corps...", 0, APLAN);                                        
                                        break;
                        }
                        break;

                case 153:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Allez-vous vous", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("taire?!!", 0, APLAN);
                                        State=152;
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("...en fait, vous", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("n'etes qu'un voyeur!", 0, APLAN);
                                        GameOver();
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("...huuum..", 0, APLAN);
                                        play_sample(JOUI, JOUI_END-JOUI);
                                        for (i = 0; i < 200; i++)
                                                wait_sync();
                                        State=160;
                                        wait_sec(100);
                                        dma_vram_copy(fille1_f  , ADR_IMG , 32 * 32 * 19);
                                        erase_text();
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Hum...Je vais vous", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("remercier d'avoir", 0, APLAN);
                                        gotoxy(9, 24);
                                        outtext_xy("pris soin de moi...", 0, APLAN);
                                        State=161;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("C'etait votre but?!", 0, APLAN);
                                        break;
                        }
                        break;

                case 161:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ohhhh...", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Je ne crois pas", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("ce que je vois!)", 0, APLAN);
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Ouiiii...", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Touchez mes seins...", 0, APLAN);                                        
                                        State=162;
                                        break;
                                case ON_SEX:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Quoi???", 0, APLAN);                                        
                                        gotoxy(9, 23);
                                        outtext_xy("Vous en voulez plus?", 0, APLAN);
                                        GameOver();
                                        break;
                        }
                        break;

                case 162:
                        switch(action)
                        {
                                case ON_TALK:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Gnnniiii..", 0, APLAN);
                                        break;
                                case ON_SEE:
                                        gotoxy(1, 22);
                                        outtext_xy("Ahriboy", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("(Tiens, un ange)", 0, APLAN);                                        
                                        break;
                                case ON_TOUCH:
                                        gotoxy(1, 22);
                                        outtext_xy("Kumiko", 0, APLAN);
                                        gotoxy(9, 22);
                                        outtext_xy("Je le fait mal pour", 0, APLAN);
                                        gotoxy(9, 23);
                                        outtext_xy("que vous vouliez", 0, APLAN);                                        
                                        gotoxy(9, 24);
                                        outtext_xy("le faire vous-meme?", 0, APLAN);                                        
                                        GameOver();
                                        break;
                                case ON_SEX:
                                        End();
                                        break;
                        }
                        break;
        }
    wait_sec(10);
}


void wait_press()
{
    uint tag;
    uint i;


    init_joypad();

    tag=0;

    while(tag == 0)
    {
        i=read_joypad1();

        if (i)
        {
                switch(i&0xff)
                {
                        case BUTTON_A:
                                tag=1;
                                break;
                        case BUTTON_B:
                                tag=1;
                                break;
                        case BUTTON_C:
                                tag=1;
                                break;
                        case BUTTON_S:
                                tag=1;
                                break;
                }
        }
    }
}


void wait_sec(nb_sec)
uint nb_sec;
{
        uint i;
        for (i=0; i<nb_sec; i++)
                wait_sync();
}


void erase_text()
{
        uint i, j;

        for (i=0; i<32; i++)
                for (j=22; j<32; j++)
                        show_tiles(0 , 0, 1, i, j, APLAN, 0);

        wait_sync();
}



void GameOver()
{

        wait_sec(100);
        clrscr();
        reset_sprites(0);

        gotoxy(9,12);
        outtext_xy("SALE PERVERS!", 0, APLAN);
        wait_sec(200);

        RAZ();

        reboot();
}

void End()
{
        uint i;
        
        clrscr();
        reset_sprites(1);

        dma_vram_copy(splash  , ADR_SPLASH , 32 * 10 * 9);

        set_colors(2, pal_splash);

        for (i=0; i<9; i++)
                show_tiles((i*10)+ADR_SPLASH/32 , (i*10) + 9 + ADR_SPLASH/32 , 2, 11, 9+i, BPLAN, 0);


        play_sample(HUMMM, HUMMM_END-HUMMM);
    
        gotoxy(1, 6);
        outtext_xy("SSSSSPPPPPLLLLLAAAAASSSSSHHHHH", 0, APLAN);                                        
        gotoxy(4, 20);
        outtext_xy("HUMMMMM...SO GOOOOOOD", 0, APLAN);

        for (i = 0; i < 200; i++)
                wait_sync();

        wait_press();
        RAZ();
        reboot();
}
