#include "genesis.h"
#include "pal_devb.h"

void Logo();

/*
 *  External references...
 */
/* in AHHH.S */
extern uchar AHHH[];
extern uchar AHHH_END[];

/* in DEF_OPEN.S */
extern ulong devbros[];

/* in PAL_DEVB.H */
/* extern uint pal_devbros[];      */

extern uint pal_black[16];

/*  Using the existing fonctions,
 *  show the DevBros Logo
 */
void Logo()
{
        register uint i, j;

        set_colors(0,pal_devbros);

        dma_vram_copy(devbros, 32, 32 * 13 * 13);

        for (i=0; i < 13; i++)
        {
                show_tiles( 1+(13*i), 13+(13*i), 0, 10, 7+i, APLAN, 0);
                wait_sync();
                wait_sync();
                wait_sync();
                wait_sync();
                wait_sync();
        }

        /* Play 'SEGA' digitized sound */
        play_sample(AHHH, AHHH_END-AHHH);
    
        /* Wait for sample to finish */
        for (i = 0; i < 200; i++)
                wait_sync();

        RAZ();
}
